## apex 1.0.0

=== DESCRIPTION ===
Package: apex
Title: Phylogenetic Methods for Multiple Gene Data
Version: 1.0.0
Authors@R: c(TJ=person("Thibaut", "Jombart", , "t.jombart@imperial.ac.uk", role = c("aut", "cre")), 
	   ZK=person("Zhian Namir", "Kamvar", email = "kamvarz@science.oregonstate.edu", role = c("aut")),
	   KS=person("Klaus", "Schliep", email="klaus.schliep@umb.edu", role = c("aut")),
	   RH=person("Rebecca", "Harris", email="rbharris@uw.edu", role = c("aut")))
Description: Toolkit for the analysis of multiple gene data. Apex implements the new S4 classes "multidna", "multiphyDat" and associated methods to handle aligned DNA sequences from multiple genes.
Depends: R (>= 3.1.3), methods, ape, phangorn
Imports: adegenet
License: GPL (>= 2)
LazyData: true
Collate: doc.R internal.R multidna.class.R multiphyDat.class.R show.R
        multidna.constructor.R multiphyDat.constructor.R accessors.R
        handling.R plot.R readfiles.R datasets.R dist.R getTree.R
        exports.R
VignetteBuilder: knitr
Suggests: testthat, knitr
NeedsCompilation: no
Packaged: 2015-04-15 14:57:02 UTC; thibaut
Author: Thibaut Jombart [aut, cre],
  Zhian Namir Kamvar [aut],
  Klaus Schliep [aut],
  Rebecca Harris [aut]
Maintainer: Thibaut Jombart <t.jombart@imperial.ac.uk>
Repository: CRAN
Date/Publication: 2015-04-15 21:32:16

## apex 1.0.1

=== DESCRIPTION ===
Package: apex
Title: Phylogenetic Methods for Multiple Gene Data
Version: 1.0.1
Authors@R: c(TJ=person("Thibaut", "Jombart", , "t.jombart@imperial.ac.uk", role = c("aut", "cre")), 
	   ZK=person("Zhian Namir", "Kamvar", email = "kamvarz@science.oregonstate.edu", role = c("aut")),
	   KS=person("Klaus", "Schliep", email="klaus.schliep@umb.edu", role = c("aut")),
	   EA=person("Eric", "Archer", email="eric.archer@noaa.gov", role = c("aut")),
	   RH=person("Rebecca", "Harris", email="rbharris@uw.edu", role = c("aut")))
Description: Toolkit for the analysis of multiple gene data. Apex implements the new S4 classes 'multidna', 'multiphyDat' and associated methods to handle aligned DNA sequences from multiple genes.
Depends: R (>= 3.1.3), methods, ape, phangorn
Imports: utils, graphics, stats, grDevices, adegenet
License: GPL (>= 2)
LazyData: true
Collate: doc.R internal.R multidna.class.R multiphyDat.class.R
        add.gaps.R rm.gaps.R show.R multidna.constructor.R
        multiphyDat.constructor.R accessors.R subset.R concatenate.R
        plot.R readfiles.R datasets.R dist.R getTree.R exports.R
VignetteBuilder: knitr
Suggests: testthat, knitr
NeedsCompilation: no
Packaged: 2015-09-07 13:15:00 UTC; thibaut
Author: Thibaut Jombart [aut, cre],
  Zhian Namir Kamvar [aut],
  Klaus Schliep [aut],
  Eric Archer [aut],
  Rebecca Harris [aut]
Maintainer: Thibaut Jombart <t.jombart@imperial.ac.uk>
Repository: CRAN
Date/Publication: 2015-09-07 18:17:44

## apex 1.0.2

=== DESCRIPTION ===
Package: apex
Title: Phylogenetic Methods for Multiple Gene Data
Version: 1.0.2
Authors@R: c(TJ=person("Thibaut", "Jombart", , "t.jombart@imperial.ac.uk", role = c("aut", "cre")),
	   ZK=person("Zhian Namir", "Kamvar", email = "kamvarz@science.oregonstate.edu", role = c("aut")),
	   KS=person("Klaus", "Schliep", email="klaus.schliep@umb.edu", role = c("aut")),
	   EA=person("Eric", "Archer", email="eric.archer@noaa.gov", role = c("aut")),
	   RH=person("Rebecca", "Harris", email="rbharris@uw.edu", role = c("aut")))
Description: Toolkit for the analysis of multiple gene data. Apex implements
    the new S4 classes 'multidna', 'multiphyDat' and associated methods to handle
    aligned DNA sequences from multiple genes.
Depends: R (>= 3.1.3), methods, ape, phangorn
Imports: utils, graphics, stats, grDevices, adegenet
License: GPL (>= 2)
LazyData: true
URL: https://github.com/thibautjombart/apex
BugReports: https://github.com/thibautjombart/apex/issues
Collate: doc.R internal.R multidna.class.R multiphyDat.class.R
        add.gaps.R rm.gaps.R show.R multidna.constructor.R
        multiphyDat.constructor.R accessors.R subset.R concatenate.R
        plot.R readfiles.R datasets.R dist.R getTree.R exports.R
VignetteBuilder: knitr
Suggests: testthat, knitr, rmarkdown
RoxygenNote: 5.0.1
NeedsCompilation: no
Packaged: 2016-12-05 14:51:05 UTC; hornik
Author: Thibaut Jombart [aut, cre],
  Zhian Namir Kamvar [aut],
  Klaus Schliep [aut],
  Eric Archer [aut],
  Rebecca Harris [aut]
Maintainer: Thibaut Jombart <t.jombart@imperial.ac.uk>
Repository: CRAN
Date/Publication: 2016-12-05 18:28:47

## apex 1.0.3

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: apex
 Title: Phylogenetic Methods for Multiple Gene Data
-Version: 1.0.2
-Authors@R: c(TJ=person("Thibaut", "Jombart", , "t.jombart@imperial.ac.uk", role = c("aut", "cre")),
+Version: 1.0.3
+Authors@R: c(TJ=person("Thibaut", "Jombart", , "thibautjombart@gmail.com", role = c("aut", "cre")),
 	   ZK=person("Zhian Namir", "Kamvar", email = "kamvarz@science.oregonstate.edu", role = c("aut")),
 	   KS=person("Klaus", "Schliep", email="klaus.schliep@umb.edu", role = c("aut")),
 	   EA=person("Eric", "Archer", email="eric.archer@noaa.gov", role = c("aut")),
@@ -21,14 +21,14 @@
         plot.R readfiles.R datasets.R dist.R getTree.R exports.R
 VignetteBuilder: knitr
 Suggests: testthat, knitr, rmarkdown
-RoxygenNote: 5.0.1
+RoxygenNote: 6.0.1
 NeedsCompilation: no
-Packaged: 2016-12-05 14:51:05 UTC; hornik
+Packaged: 2017-09-20 10:19:35 UTC; thibaut
 Author: Thibaut Jombart [aut, cre],
   Zhian Namir Kamvar [aut],
   Klaus Schliep [aut],
   Eric Archer [aut],
   Rebecca Harris [aut]
-Maintainer: Thibaut Jombart <t.jombart@imperial.ac.uk>
+Maintainer: Thibaut Jombart <thibautjombart@gmail.com>
 Repository: CRAN
-Date/Publication: 2016-12-05 18:28:47
+Date/Publication: 2017-09-23 14:19:41 UTC

## apex 1.0.4

=== DESCRIPTION ===
Package: apex
Title: Phylogenetic Methods for Multiple Gene Data
Version: 1.0.4
Authors@R: c(KS=person("Klaus", "Schliep", email="klaus.schliep@umb.edu", role = c("aut", "cre"), comment = c(ORCID = "0000-0003-2941-0161")),
       TJ=person("Thibaut", "Jombart", , "t.jombart@imperial.ac.uk", role = c("aut")),
	   ZK=person("Zhian Namir", "Kamvar", email = "kamvarz@science.oregonstate.edu", role = c("aut")),
	   EA=person("Eric", "Archer", email="eric.archer@noaa.gov", role = c("aut")),
	   RH=person("Rebecca", "Harris", email="rbharris@uw.edu", role = c("aut")))
Description: Toolkit for the analysis of multiple gene data (Jombart et al. 2017) <doi:10.1111/1755-0998.12567>. 
    Apex implements the new S4 classes 'multidna', 'multiphyDat' and associated methods to handle aligned DNA sequences from multiple genes.
Depends: R (>= 3.1.3), methods, ape, phangorn
Imports: utils, graphics, stats, adegenet
License: GPL (>= 2)
LazyData: true
URL: https://github.com/thibautjombart/apex
BugReports: https://github.com/thibautjombart/apex/issues
Collate: doc.R internal.R multidna.class.R multiphyDat.class.R
        add.gaps.R rm.gaps.R show.R multidna.constructor.R
        multiphyDat.constructor.R accessors.R subset.R concatenate.R
        plot.R readfiles.R datasets.R dist.R getTree.R exports.R
VignetteBuilder: knitr
Suggests: testthat, knitr, rmarkdown
Encoding: UTF-8
RoxygenNote: 7.1.0
NeedsCompilation: no
Packaged: 2020-04-10 09:51:00 UTC; klaus
Author: Klaus Schliep [aut, cre] (<https://orcid.org/0000-0003-2941-0161>),
  Thibaut Jombart [aut],
  Zhian Namir Kamvar [aut],
  Eric Archer [aut],
  Rebecca Harris [aut]
Maintainer: Klaus Schliep <klaus.schliep@umb.edu>
Repository: CRAN
Date/Publication: 2020-04-11 05:00:06 UTC

## apex 1.0.6

=== DESCRIPTION ===
Package: apex
Title: Phylogenetic Methods for Multiple Gene Data
Version: 1.0.6
Authors@R: c(KS=person("Klaus", "Schliep", email="klaus.schliep@gmail.com", role = c("aut", "cre"), comment = c(ORCID = "0000-0003-2941-0161")),
       TJ=person("Thibaut", "Jombart", , "t.jombart@imperial.ac.uk", role = c("aut")),
	   ZK=person("Zhian Namir", "Kamvar", email = "kamvarz@science.oregonstate.edu", role = c("aut")),
	   EA=person("Eric", "Archer", email="eric.archer@noaa.gov", role = c("aut")),
	   RH=person("Rebecca", "Harris", email="rbharris@uw.edu", role = c("aut")))
Description: Toolkit for the analysis of multiple gene data (Jombart et al. 2017) <doi:10.1111/1755-0998.12567>. 
    'apex' implements the new S4 classes 'multidna', 'multiphyDat' and associated methods to handle aligned DNA sequences from multiple genes.
Depends: R (>= 3.1.3), methods, ape, phangorn
Imports: utils, graphics, stats, adegenet
License: GPL (>= 2)
URL: https://github.com/thibautjombart/apex
BugReports: https://github.com/thibautjombart/apex/issues
Collate: doc.R internal.R multidna.class.R multiphyDat.class.R
        add.gaps.R rm.gaps.R show.R multidna.constructor.R
        multiphyDat.constructor.R accessors.R subset.R concatenate.R
        plot.R readfiles.R datasets.R dist.R getTree.R exports.R
VignetteBuilder: knitr
Suggests: testthat, knitr, rmarkdown
Encoding: UTF-8
RoxygenNote: 7.3.0
NeedsCompilation: no
Packaged: 2024-01-29 15:32:08 UTC; klaus
Author: Klaus Schliep [aut, cre] (<https://orcid.org/0000-0003-2941-0161>),
  Thibaut Jombart [aut],
  Zhian Namir Kamvar [aut],
  Eric Archer [aut],
  Rebecca Harris [aut]
Maintainer: Klaus Schliep <klaus.schliep@gmail.com>
Repository: CRAN
Date/Publication: 2024-01-31 19:40:07 UTC

## apex 1.0.7

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: apex
 Title: Phylogenetic Methods for Multiple Gene Data
-Version: 1.0.6
+Version: 1.0.7
 Authors@R: c(KS=person("Klaus", "Schliep", email="klaus.schliep@gmail.com", role = c("aut", "cre"), comment = c(ORCID = "0000-0003-2941-0161")),
        TJ=person("Thibaut", "Jombart", , "t.jombart@imperial.ac.uk", role = c("aut")),
 	   ZK=person("Zhian Namir", "Kamvar", email = "kamvarz@science.oregonstate.edu", role = c("aut")),
@@ -20,14 +20,15 @@
 VignetteBuilder: knitr
 Suggests: testthat, knitr, rmarkdown
 Encoding: UTF-8
-RoxygenNote: 7.3.0
+RoxygenNote: 7.3.2
 NeedsCompilation: no
-Packaged: 2024-01-29 15:32:08 UTC; klaus
-Author: Klaus Schliep [aut, cre] (<https://orcid.org/0000-0003-2941-0161>),
+Packaged: 2025-07-24 11:58:32 UTC; klaus
+Author: Klaus Schliep [aut, cre] (ORCID:
+    <https://orcid.org/0000-0003-2941-0161>),
   Thibaut Jombart [aut],
   Zhian Namir Kamvar [aut],
   Eric Archer [aut],
   Rebecca Harris [aut]
 Maintainer: Klaus Schliep <klaus.schliep@gmail.com>
 Repository: CRAN
-Date/Publication: 2024-01-31 19:40:07 UTC
+Date/Publication: 2025-07-24 14:10:02 UTC

## apex 1.4.7

=== Makefile ===
ARCH ?= arm

# Preserve environment for the cross-compiler
ENV_CROSS_COMPILE:=$(CROSS_COMPILE)

VERSION = 1
PATCHLEVEL = 4
SUBLEVEL = 7
EXTRAVERSION =
#NAME=Zonked Quokka

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's of
# unavoidable when linking the built-in.o targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call sparse as part of compilation of C files
# Use 'make C=1' to enable sparse checking

ifdef C
  ifeq ("$(origin C)", "command line")
    KBUILD_CHECKSRC = $(C)
  endif
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif
ifdef M
  ifeq ("$(origin M)", "command line")
    KBUILD_EXTMOD := $(M)
  endif
endif


# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntax'es are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assigment takes precedence over the KBUILD_OUTPUT environment variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifdef O
  ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
  endif
endif

# That's our default target when none is given on the command line
.PHONY: _all
_all:

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

.PHONY: $(MAKECMDGOALS)

$(filter-out _all,$(MAKECMDGOALS)) _all:
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT)		\
	KBUILD_SRC=$(CURDIR)	     KBUILD_VERBOSE=$(KBUILD_VERBOSE)	\
	KBUILD_CHECK=$(KBUILD_CHECK) KBUILD_EXTMOD="$(KBUILD_EXTMOD)"	\
	-f $(CURDIR)/Makefile $@

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
.PHONY: all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
TOPDIR		:= $(srctree)
# FIXME - TOPDIR is obsolete, use srctree/objtree
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)

export srctree objtree VPATH TOPDIR

nullstring :=
space      := $(nullstring) # end of line

# Take the contents of any files called localversion* and the config
# variable CONFIG_LOCALVERSION and append them to KERNELRELEASE. Be
# careful not to include files twice if building in the source
# directory. LOCALVERSION from the command line override all of this

ifeq ($(objtree),$(srctree))
localversion-files := $(wildcard $(srctree)/localversion*)
else
localversion-files := $(wildcard $(objtree)/localversion* $(srctree)/localversion*)
endif

LOCALVERSION = $(subst $(space),, \
	       $(shell cat /dev/null $(localversion-files)) \
	       $(subst ",,$(CONFIG_LOCALVERSION)))

APEXRELEASE:=$(VERSION).$(PATCHLEVEL)
ifneq ($(SUBLEVEL),)
APEXRELEASE+=.$(SUBLEVEL)
endif
ifneq ($(EXTRAVERSION),)
APEXRELEASE+=$(EXTRAVERSION)
endif
ifneq ($(LOCALVERSION),)
APEXRELEASE+=$(LOCALVERSION)
endif
APEXRELEASE:=$(subst $(space),,$(APEXRELEASE))

# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and
# SUBARCH is subsequently ignored.

SUBARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
				  -e s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/s390x/s390/ -e s/parisc64/parisc/ )

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile

ARCH		?= $(SUBARCH)

# elf: Removed in favor of the config file
#CROSS_COMPILE	?=

# Architecture as present in compile.h
UTS_MACHINE := $(ARCH)

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC	= gcc
HOSTCXX	= g++
HOSTCFLAGS	= -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
HOSTCXXFLAGS	= -O2

#	Decide whether to build built-in, modular, or both.
#	Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are uptodate before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN KBUILD_VERBOSE
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing wil be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's usefull
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE

######
# cc support functions to be used (only) in arch/$(ARCH)/Makefile
# See documentation in Documentation/kbuild/makefiles.txt

# cc-option
# Usage: cflags-y += $(call gcc-option, -march=winchip-c6, -march=i586)

cc-option = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
	     > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

# For backward compatibility
check_gcc = $(warning check_gcc is deprecated - use cc-option) \
	    $(call cc-option, $(1),$(2))

# cc-option-yn
# Usage: flag := $(call gcc-option-yn, -march=winchip-c6)
cc-option-yn = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
		> /dev/null 2>&1; then echo "y"; else echo "n"; fi;)

# cc-version
# Usage gcc-ver := $(call cc-version $(CC))
cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh \
	      $(if $(1), $(1), $(CC)))


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

# For maximum performance (+ possibly random breakage, uncomment
# the following)

#MAKEFLAGS += -rR

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE_)as
LD		= $(CROSS_COMPILE_)ld
CC		= $(CROSS_COMPILE_)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE_)ar
NM		= $(CROSS_COMPILE_)nm
STRIP		= $(CROSS_COMPILE_)strip
OBJCOPY		= $(CROSS_COMPILE_)objcopy
OBJDUMP		= $(CROSS_COMPILE_)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= echo sparse
CHECKFLAGS     :=
MODFLAGS	= -DMODULE
CFLAGS_MODULE   = $(MODFLAGS)
AFLAGS_MODULE   = $(MODFLAGS)
LDFLAGS_MODULE  = -r
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=

NOSTDINC_FLAGS  = -nostdinc -iwithprefix include

# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
LINUXINCLUDE    := -Iinclude \
		   $(if $(KBUILD_SRC),-Iinclude2 -I$(srctree)/include)

CPPFLAGS        := -D__KERNEL__ $(LINUXINCLUDE)

CFLAGS		:= -Wall -Wstrict-prototypes -Wno-trigraphs \
		   -fno-strict-aliasing -fno-common \
		   -fno-builtin-printf -g # -mthumb-interwork
AFLAGS		:= -D__ASSEMBLY__ # -mthumb-interwork

export	VERSION PATCHLEVEL SUBLEVEL EXTRAVERSION LOCALVERSION APEXRELEASE \
	ARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC \
	CPP AR NM STRIP OBJCOPY OBJDUMP MAKE AWK GENKSYMS PERL UTS_MACHINE \
	HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export CFLAGS CFLAGS_KERNEL CFLAGS_MODULE
export AFLAGS AFLAGS_KERNEL AFLAGS_MODULE

# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# The temporary file to save gcc -MD generated dependencies must not
# contain a comma
comma := ,
depfile = $(subst $(comma),_,$(@D)/.$(@F).d)

=== arm-kernel-shim/Makefile ===
# Makefile

PACKAGE:=arm-kernel-shim
VERSION:=1.0

TOOLS:=/usr/arm-linux/gcc3/arm-linux-
CC=$(TOOLS)gcc
LD=$(TOOLS)ld
OBJCOPY=$(TOOLS)objcopy

CFLAGS:=-g -Os  -nostartfiles -nostdlib
LDFLAGS:= -g -X -Map shim.map -Ttext 0

SRCS:= shim.lds main.c
OBJS:=$(SRCS:.c=.o)

$(PACKAGE).bin: $(PACKAGE)
	$(OBJCOPY) -O binary $< $@

$(PACKAGE): $(OBJS)
	$(LD) $(LDFLAGS) $(OBJS) -o $@

%.o: %.c
	$(CC) -c $(CFLAGS) $< -o $@


.PHONY: clean
clean:
	-rm *.o $(PACKAGE) $(PACKAGE).bin *~

.PHONY: package
package: $(PACKAGE)-$(VERSION).tar.gz

$(PACKAGE)-$(VERSION).tar.gz:
	[ ! -d $(PACKAGE)-$(VERSION) ] || rm -rf $(PACKAGE)-$(VERSION)
	svn export -q file:///svn/tools/trunk/$(PACKAGE) $(PACKAGE)-$(VERSION)
	tar zcvf $(PACKAGE)-$(VERSION).tar.gz $(PACKAGE)-$(VERSION)
	rm -rf $(PACKAGE)-$(VERSION)

=== usr/Makefile ===
# Makefile

CROSS_COMPILE ?= /usr/arm-linux/gcc3/arm-linux-
#CFLAGS ?= -I/a/trans/embedded/m3/tools-target/usr/include
#LDFLAGS ?= -L/a/trans/embedded/m3/tools-target/usr/lib

CFLAGS += -I../include

SRCS:=printenv.cc
OBJS:=$(SRCS:.cc=.o)

CC=$(CROSS_COMPILE)g++
CXX=$(CROSS_COMPILE)g++
LD=$(CROSS_COMPILE)ld
STRIP=$(CROSS_COMPILE)strip

CFLAGS+= -Os -g -c

TARGETS:=printenv

.PHONY: all
all: $(TARGETS)

printenv: printenv.o

printenv: printenv.o
	@echo linking $@
	@$(CC) $(CFLAGS_LINK) -o $@ $^ $(LIBRARIES) $($@_LIB)

%.o: %.cc
	@echo compile $@ $(CCFLAGS)
	@$(CXX) $(CFLAGS) -o $@ $<

.PHONY: clean
clean:
	-rm $(TARGETS) *.o

=== src/apex/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

obj-y := init.o console.o console-printf.o
obj-y += command.o cmd-version.o cmd-help.o cmd-boot.o

obj-$(CONFIG_COMMAND_HISTORY)   += command-history.o

obj-$(CONFIG_ENV)		+= env.o

obj-$(CONFIG_CMD_CHECKSUM)	+= cmd-checksum.o
obj-$(CONFIG_CMD_COMPARE)	+= cmd-compare.o
obj-$(CONFIG_CMD_COPY)		+= cmd-copy.o
obj-$(CONFIG_CMD_DRVINFO)	+= cmd-drvinfo.o
obj-$(CONFIG_CMD_DUMP)		+= cmd-dump.o
obj-$(CONFIG_CMD_ENV)		+= cmd-env.o
obj-$(CONFIG_CMD_ERASE)		+= cmd-erase.o
obj-$(CONFIG_CMD_FILL)		+= cmd-fill.o
obj-$(CONFIG_CMD_GO)		+= cmd-go.o
obj-$(CONFIG_CMD_INFO)		+= cmd-info.o
obj-$(CONFIG_CMD_PAUSE)		+= cmd-pause.o
obj-$(CONFIG_CMD_WAIT)		+= cmd-wait.o
obj-$(CONFIG_CMD_XRECEIVE)	+= cmd-xreceive.o
obj-$(CONFIG_CMD_ALIAS)		+= cmd-alias.o

ifneq ($(CONFIG_THUMB),)
# CFLAGS += -mthumb
endif

CFLAGS_cmd-version.o += -DAPEXRELEASE=\"$(APEXRELEASE)\"

=== src/lib/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

lib-y := vsprintf.o ctype.o
lib-y += strlen.o strnlen.o strchr.o strlcpy.o strcat.o strcpy.o
lib-y += strcmp.o strnicmp.o strcspn.o
lib-y += memcmp.o memset.o
lib-$(CONFIG_SMALL) += memcpy.o memmove.o
lib-y += crc32.o xmodem.o
lib-y += spinner.o
lib-$(CONFIG_ENV) += env.o
lib-y += dump.o
lib-y += zlib.o zlib-heap.o
#lib-y += png.o
lib-y += pngr.o
lib-y += sort.o
lib-$(CONFIG_ALIASES) += alias.o
lib-y += lookup.o

ifneq ($(CONFIG_THUMB),)
CFLAGS_vsprintf.o	+= -mthumb
CFLAGS_ctype.o		+= -mthumb
#CFLAGS_xmodem.o		+= -mthumb -mcaller-super-interworking
CFLAGS_strlen.o		+= -mthumb
CFLAGS_strnlen.o	+= -mthumb
CFLAGS_strrchr.o	+= -mthumb
CFLAGS_strlcpy.o	+= -mthumb
CFLAGS_strnicmp.o	+= -mthumb
CFLAGS_strcpy.o		+= -mthumb
CFLAGS_memcmp.o		+= -mthumb
CFLAGS_memset.o		+= -mthumb
CFLAGS_memcpy.o		+= -mthumb
CFLAGS_memmove.o	+= -mthumb
CFLAGS_png.o		+= -mthumb
endif

#lib-y += div64.o
#lib-y += udiv.o
#CFLAGS_vsprintf.o += -mthumb
#CFLAGS_crc32.o = -mthumb -mthumb-interwork

=== src/mach-ixp42x/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

# npe-interface is in a world of it's own.  It has to build with
#   headers from the Intel Access Library which are incompatible with
#   header in the project.  So, it is isolated from the loader and
#   wrapper calls are defined to allow the header domain of the this
#   one source file to be separate from the header domain of the rest
#   of the application.

CFLAGS_npe-interface.o\
  += -I-\
     -Isrc/mach-ixp42x/_intel/ixp400_xscale_sw/src/include \
     -Isrc/mach-ixp42x/_intel/ixp_osal/include\
     -Isrc/mach-ixp42x/_intel/ixp_osal/os/linux/include/core\
     -Isrc/mach-ixp42x/_intel/ixp_osal/os/linux/include/modules/bufferMgt\
     -Isrc/mach-ixp42x/_intel/ixp_osal/os/linux/include/platforms/ixp400\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/modules/ioMem\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/modules/bufferMgt\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/platforms/ixp400\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/platforms/ixp400/bufferMgt\
     -Isrc/mach-ixp42x/_intel/linux/include\
     -Isrc/mach-ixp42x/_intel/linux/include/linux\
     -Isrc/mach-ixp42x/_intel/linux/include/asm/arch\
     -Isrc/mach-ixp42x/_intel/ixp400_xscale_sw/npeLib

obj-y := serial.o env.o cpuinfo.o
obj-y += initialize.o timer.o pci.o

obj-x$(CONFIG_MACH_NSLU2)$(CONFIG_SPINNER) += spinner-nslu2.o
obj-$(CONFIG_INTERRUPTS)	+= exception_vectors.o

obj-$(CONFIG_NPE)		+= npe.o npe-interface.o

obj-y				+= cmd-reset.o

obj-y += $(obj-xyy)

libs-$(CONFIG_NPE) += _intel/lib/libnpeDl.a
newlibs += $(obj)/_intel/lib/libnpeDl.a

#libs-$(CONFIG_NPE) := _intel/

=== src/mach-lh7a40x/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

obj-y := arch.o initialize.o serial.o timer.o env.o cpuinfo.o
obj-$(CONFIG_CLCDC)		+= clcdc.o
obj-$(CONFIG_CODEC)		+= codec.o
obj-$(CONFIG_ADC)		+= adc.o
obj-y				+= cmd-reset.o
obj-y				+= cmd-standby.o
obj-$(CONFIG_CMD_ARM920_TEST)	+= cmd-cp15test.o
obj-$(CONFIG_RELOCATE_COMPANION_EVT1) += relocate-companion.o
obj-$(CONFIG_MACH_COMPANION)    += clcdc-companion.o
obj-$(CONFIG_RELOCATE_COMPANION_EVT2) += preinitialization-companion.o

obj-$(CONFIG_MACH_COMPANION)	+= test-companion.o

=== debian/changelog ===
apex (1.4.7) unstable; urgency=low

  * New command line starts RTC.
  * Moved the environment to the same block as the loader.

 --  Marc Singer <elf@debian.org>  Sun, 22 Oct 2006 14:20:13 -0700

apex (1.4.5) unstable; urgency=low

  * Fixed the sort comparison function in the fis driver so that the skips
    are ordered by offset address. 
  * Changed the default startup to copy from fis://kernel and
    fis://ramdisk.  We no longer expect there to be SERCOMM headers on the
    kernel or ramdisk images.  Freedom.

 --  Marc Singer <elf@debian.org>  Fri, 18 Aug 2006 09:44:34 -0700

apex (1.4.4) unstable; urgency=low

  * Small changes to the configurations for debian builds: noirqdebug
    added command line, removed root= from command line. 
  * Revised copyright file to conform to approved practices.

 -- Marc Singer <elf@debian.org>  Mon, 14 Aug 2006 17:06:58 -0700

apex (1.4.3) unstable; urgency=low

  * Added fis_skip_descriptor interpretation to the FIS driver.  This
    allows for loading the kernel from FIS partitions that are broken-up
    by SERCOMM headers to cope with RedBoot shortcomings.

 -- Marc Singer <elf@debian.org>  Sun, 13 Aug 2006 17:28:55 -0700

apex (1.4.0) unstable; urgency=low

  * Revised several key systems for the sake of running APEX in LE mode on
    a BE system.  APEX now functions as a second-stage boot loader on the
    nslu2.

 -- Marc Singer <elf@debian.org>  Wed, 26 Jul 2006 00:57:13 -0700

apex (1.3.30) unstable; urgency=low

  * Initial release for configuration debian-nslu2-arm_config (and armeb).

 -- Marc Singer <elf@debian.org>  Thu, 20 Jul 2006 11:36:21 -0700

=== debian/control ===
Source: apex
Section: admin
Priority: optional
Maintainer: Marc Singer <elf@debian.org>
Standards-Version: 3.7.2
Build-Depends: perl

Package: apex-nslu2
Architecture: arm armeb
Depends:
Description: APEX Boot Loader for Linksys NSLU2 
 The APEX Boot Loader is a modular and retargetable firmware loader
 suitable for embedded systems.  
 .
 This package is a version of APEX configured for the Linksys NSLU2
 network appliance.  In this case, APEX is used as a second stage
 loader so that Redboot, as installed by the manufacturer, may remain.
 . 
 The APEX command line offers a comfortable (e.g. command line editing
 and history) and extensible platform for development and production
 uses.
 .
 <http://wiki.buici.com/wiki/Apex_Bootloader>

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules file - for GNU Hello.
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified

package = apex-nslu2
docdir = debian/tmp/usr/share/doc/$(package)

DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
CONFIG         := debian-nslu2-$(DEB_BUILD_ARCH)_config

CC = gcc
CFLAGS = -g -Wall
INSTALL_PROGRAM = install


ifeq (arm,$(DEB_BUILD_ARCH))
 ENDIAN:=l
endif
ifeq (armeb,$(DEB_BUILD_ARCH))
 ENDIAN:=b
endif

# We must not change the build options.
#ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
#  CFLAGS += -O2
#endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
  INSTALL_PROGRAM += -s
endif

build:
	$(checkdir)
	$(MAKE) $(CONFIG)
	$(MAKE)
	touch build

clean:
	$(checkdir)
	rm -f build
	-$(MAKE) -i distclean
	rm -rf *~ debian/tmp debian/*~ debian/files* debian/substvars

binary-indep:	checkroot build
	$(checkdir)
# There are no architecture-independent files to be uploaded
# generated by this package.  If there were any they would be
# made here.

binary-arch:	checkroot build
	$(checkdir)
	rm -rf debian/tmp
	install -d debian/tmp/DEBIAN $(docdir)
#	install -m 755 debian/postinst debian/prerm debian/tmp/DEBIAN
#	$(MAKE) INSTALL_PROGRAM="$(INSTALL_PROGRAM)" \
#		prefix=$$(pwd)/debian/tmp/boot install
	install -d debian/tmp/boot
	cp src/arch-arm/rom/apex.bin $$(pwd)/debian/tmp/boot/apex.flash
# Headerization done by slugimage
#	tools/headerize $(ENDIAN) $$(pwd)/debian/tmp/boot/apex.flash
#	cd debian/tmp && mv usr/info usr/man usr/share
#	cp -a NEWS $(docdir)
	cp -a debian/copyright $(docdir)
	cp -a debian/changelog $(docdir)/changelog.Debian
	cp -a ChangeLog $(docdir)/changelog
	cd $(docdir) && gzip -9 changelog changelog.Debian
#	gzip -r9 debian/tmp/usr/share/man
#	gzip -9 debian/tmp/usr/share/info/*
#	dpkg-shlibdeps debian/tmp/usr/bin/hello
	dpkg-gencontrol -isp
	chown -R root:root debian/tmp
	chmod -R u+w,go=rX debian/tmp
	dpkg --build debian/tmp ..

define checkdir
	test -f src/apex/init.c -a -f debian/rules
endef

binary: binary-indep binary-arch

checkroot:
	$(checkdir)
	test $$(id -u) = 0

.PHONY: binary binary-arch binary-indep clean checkroot
